#include <iostream>
#include <stdio.h>
#include <cstdlib>
#include <unistd.h>
#include <ctype.h>
#include "phisq.h"
//#include "correl.h"
using namespace std;

int main(int argc, char **argv)
{
    int L=24;
    int wstep=10000;
    int step=1000000;
    //double beta=0.44068679350977147;
    double beta=0.42;
    //double J2=1;
    int c;
    //int C=0;
    int nsim=0;
    int dstep=5;
    int numpts=20;
    int verb=0;
    while((c=getopt(argc,argv,"L:b:a:B:j:C:n:v:")) != -1)
        switch(c)
        {
            case 'L': L     = atoi(optarg); break;
            case 'b': wstep = atoi(optarg); break;
            case 'a': step  = atoi(optarg); break;
            case 'B': beta  = atof(optarg); break;
            //case 'j': J2    = atof(optarg); break;
           // case 'C': C     = atoi(optarg); break;
            case 'n': nsim  = atoi(optarg); break;
            case 'v': verb  = atoi(optarg); break;
            case '?':
            if(optopt=='c')
                        std::cerr<<"Option -" << optopt << "requires an argument.\n";
                    else if(isprint(optopt))
                        std::cerr<<"Unknown option '-" << optopt << "'.\n";
                    else
                        std::cerr << "Unknown option character.\n";
                    return 1;
            default:
                       abort();
        };
   cout<<"beta "<<beta<<endl;
   cout<<"warmsteps "<<wstep<<endl;
   cout<<"steps "<<step<<endl;
   //cout<<"J2 "<<J2<<endl;
   //cout<<"C " <<C<<endl;
   cout<<"v " <<verb<<endl;

    PHISQ phisq(L,beta,nsim,verb);
    //Correl correl(nsim);
    //warmup
    clock_t t1,t2; //clocks for timing information
    t1=clock();

    phisq.cold();

    for (int i=0; i<wstep; i++)
    {
        phisq.performHK(0);

    }


    t2=clock();

    double steptime = (t2-t1)/(double)CLOCKS_PER_SEC/wstep;
    cout << "before timestep ~ " << steptime << " per frame; " << endl;
    //if (C==1)
    //{
    //correl=Correl(dstep,numpts,phisq.Ntotal,beta);
    //cout<<" nombre total"<<(double)(step/dstep)*phisq.Ntotal<<endl;
    //}
    t1=clock();

    for (int i=0; i<step; i++)
    {
        phisq.performHK(1);
        if (i%5 ==0) phisq.thermo_update(1);

    //    if (C==1)
     //   {if (i%dstep == 0) correl.updateCorrel(phisq.Phi);}
    }
    if (phisq.Magne!= phisq.magnecheck())
    {cout<<" "<<phisq.Magne<<"avant "<<phisq.magnecheck()<<endl;}
    phisq.performHK(2);
    phisq.thermo_update(2);
   // if (C==1) correl.writeCorrel(nsim);
    t2=clock();
    steptime = (t2-t1)/(double)CLOCKS_PER_SEC/step;
    cout << " after timestep ~ " << steptime << " per frame; " << endl;

    return 0;
}
